﻿Procedure ImageToColor(image, newcolor)
  Protected w, h, x, y, v, gray
  w = ImageWidth(image)
  h = ImageHeight(image)
  StartDrawing(ImageOutput(image))
  For x = 0 To w - 1
    For y = 0 To h - 1
      gray = Point(x, y)
      Plot(x, y, newcolor)
    Next
  Next
  StopDrawing()
EndProcedure

Procedure draw_box_lined_flat(parent_canvas, value.f, units_text$="n/a",fntcol = 0, iconimg = -1, bgcol = 0,barcol = 0, min.f = 0, max.f = 100, decimals = 0, segments = 25)
  If StartVectorDrawing(CanvasVectorOutput(parent_canvas))
    ScaleCoordinates(DesktopResolutionX(), DesktopResolutionY())
    AddPathBox(0, 0, GadgetWidth(parent_canvas), GadgetHeight(parent_canvas))
    VectorSourceColor(RGBA(255,255,255,255))   
    FillPath()   
    
    y1.f = GadgetWidth(parent_canvas) /12
    If iconimg <> - 1
      MovePathCursor(GadgetWidth(parent_canvas)/4, y1)
      ImageToColor(iconimg, fntcol)
      DrawVectorImage(ImageID(iconimg), 255, GadgetWidth(parent_canvas)/2, GadgetWidth(parent_canvas)/2)
    EndIf
    
    
    y1 = y1 + GadgetWidth(parent_canvas)/2 + VectorTextHeight(units_text$)/2 + GadgetWidth(parent_canvas)/12
    
    If fntcol = 0
      VectorSourceColor(RGBA(0,0,0,255))
    Else
      VectorSourceColor(fntcol)
    EndIf
    
    VectorFont(FontID(0), GadgetWidth(parent_canvas)/6)
    MovePathCursor((GadgetWidth(parent_canvas) - VectorTextWidth(units_text$))/2,y1);
    DrawVectorText(units_text$)
    y1 = y1 + VectorTextHeight(units_text$) 
    
    VectorFont(FontID(0), GadgetWidth(parent_canvas)/4)
    text$ = StrF(value,decimals)
    
    y2 = (GadgetHeight(parent_canvas) - VectorTextHeight(text$)) - GadgetWidth(parent_canvas)/12
    
    MovePathCursor((GadgetWidth(parent_canvas) - VectorTextWidth(text$))/2, y2);
    DrawVectorText(text$)
    
    y2 = y2 - VectorTextHeight(text$)/2  - GadgetWidth(parent_canvas)/12
    
    If barcol = 0
      barcol = RGBA(0, 0, 0, 255)
    EndIf 
    
    Color32.q = barcol
    Color32 = Color32 & $FFFFFFFF 
    
    If Alpha(Color32) > 210
      VectorSourceColor(RGBA(Red(Color32), Green(Color32), Blue(Color32),  Alpha(Color32) - 200))
    EndIf
    
    graph_height.f =  y2 - y1
    segment_height = (graph_height/segments)

    
    For i = 0 To segments - 1
      MovePathCursor(GadgetWidth(parent_canvas)/4, y2 - (segment_height * i))
      AddPathLine(3 *(GadgetWidth(parent_canvas)/4),  y2 -  (segment_height * i) ) 
      StrokePath(GadgetHeight(parent_canvas)/80, #PB_Path_RoundEnd);
    Next
    
    range.f = Abs(max - min)
    position.f = value/range + Abs(min)/range
    
    VectorSourceColor(barcol)
    
    For i = 0 To (segments - 1)*position
      MovePathCursor(GadgetWidth(parent_canvas)/4, y2 - (segment_height * i))
      AddPathLine(3 *(GadgetWidth(parent_canvas)/4), y2 - (segment_height * i)) 
      StrokePath(GadgetHeight(parent_canvas)/80, #PB_Path_RoundEnd);
    Next 
    
    StopVectorDrawing()
  EndIf
EndProcedure

UsePNGImageDecoder()

If OpenWindow(0, 0, 0, 300, 300, "Flat Bargraph Vertical", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
  AddWindowTimer(0, 123, 500)
  LoadFont(0, "Verdana", 20,  #PB_Font_HighQuality); | #PB_Font_Bold
  LoadImage(0, #PB_Compiler_FilePath  + "/icons/weather.png")
  LoadImage(1, #PB_Compiler_FilePath  + "/icons/humidity.png")
  CanvasGadget(10, 0, 0,WindowWidth(0)/5,WindowHeight(0))
  CanvasGadget(11, WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
  CanvasGadget(12, 2*WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
  CanvasGadget(13,3* WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
  CanvasGadget(14,4* WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
  Repeat
    
    If Event = #PB_Event_Timer And EventTimer() = 123
      draw_box_lined_flat(10,Random(100,0))
      draw_box_lined_flat(11,(Random(700,0)-200)/10,"°C",RGBA(3,37,126,255),0,0,RGBA(3,37,126,255),-20,50,1)
      draw_box_lined_flat(12,Random(100,0),"%",RGBA(139,0,139,255),1,0,RGBA(139,0,139,255),0,100)
      draw_box_lined_flat(13,Random(100,0),"%",RGBA(0,128,0,255),1,0,RGBA(0,128,0,255),0,100)
      draw_box_lined_flat(14,Random(100,0),"%",RGBA(100,100,100,255),1,0,RGBA(255,140,0,255),0,100)
    EndIf
    
    If event = #PB_Event_SizeWindow
      ResizeGadget(10, 0, 0, WindowWidth(0)/5, WindowHeight(0))
      ResizeGadget(11,WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
      ResizeGadget(12,2*WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
      ResizeGadget(13,3*WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
      ResizeGadget(14,4*WindowWidth(0)/5, 0, WindowWidth(0)/5, WindowHeight(0))
    EndIf
    Event = WaitWindowEvent()
  Until Event = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.71 LTS (Windows - x64)
; CursorPosition = 105
; FirstLine = 81
; Folding = -
; EnableXP